# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .alert_entity_type import AlertEntityType
from .alert_status import AlertStatus
from .alert_status_reason import AlertStatusReason
from .alert_type import AlertType
from .detailed_alert_schema_content import DetailedAlertSchemaContent
from .policy_severity import PolicySeverity
from .resolved_alert_source import ResolvedAlertSource
from .risk_type import RiskType


class DetailedAlertSchema(pydantic.BaseModel):
    id: str
    policy_id: str
    entity_id: typing.Optional[str]
    entity_type: AlertEntityType
    status: AlertStatus
    status_reason: AlertStatusReason
    type: AlertType
    content: DetailedAlertSchemaContent
    resolved_alert_source: typing.Optional[ResolvedAlertSource]
    occurrences: int
    organization_id: int
    connector_id: int
    created_at: typing.Optional[str]
    opened_at: typing.Optional[str]
    last_modified: str
    connector_name: str = pydantic.Field(alias="Connector__name")
    severity: PolicySeverity
    risk_type: typing.Optional[RiskType]
    tags: typing.List[str]
    frameworks: typing.List[str]
    name: str
    description: str
    recommendation: typing.Optional[str]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
