# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .access_permissions import AccessPermissions


class DetailedIamGroupSchema(pydantic.BaseModel):
    organization_id: int
    connector_id: int
    name: str
    created_at: str
    users: int
    arn: str
    access_policies_checksum: typing.Optional[str]
    id: str
    discovered_at: str
    last_seen_at: str
    connector_name: str = pydantic.Field(alias="Connector__name")
    permissions: typing.List[AccessPermissions]
    accessible_data_stores: int

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
