# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .event_log_action import EventLogAction
from .event_log_entity_type import EventLogEntityType


class EventLogRow(pydantic.BaseModel):
    id: str
    organization_id: int
    action_time: str
    category: EventLogEntityType
    action: EventLogAction
    user_id: typing.Optional[int]
    entity_id: typing.Optional[str]
    properties: typing.Dict[str, str]
    user_name: typing.Optional[str]
    user_email: typing.Optional[str]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
