# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .access_permissions import AccessPermissions
from .context_label_schema import ContextLabelSchema
from .data_class_item import DataClassItem
from .iam_access_key_schema import IamAccessKeySchema
from .identity_origin import IdentityOrigin
from .provider_schema import ProviderSchema


class IdentitySchema(pydantic.BaseModel):
    organization_id: int
    connector_id: int
    id: str
    name: str
    origin: IdentityOrigin
    provider: ProviderSchema
    roles: int
    groups: int
    findings_count: typing.Optional[int]
    permissions: typing.List[AccessPermissions]
    data_classes: typing.Optional[typing.List[DataClassItem]]
    created_at: typing.Optional[str]
    last_activity: typing.Optional[str]
    connector_name: str = pydantic.Field(alias="Connector__name")
    access_keys: typing.List[IamAccessKeySchema]
    context_labels: typing.List[ContextLabelSchema]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
