# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .account_type import AccountType
from .app_schemas_assets_public_access_level import AppSchemasAssetsPublicAccessLevel
from .asset_type import AssetType
from .context_label_schema import ContextLabelSchema
from .data_asset_props import DataAssetProps
from .data_class_item import DataClassItem
from .similar_assets_props import SimilarAssetsProps
from .similarity_type import SimilarityType


class SimilarAssetSchema(pydantic.BaseModel):
    id: str
    connector_id: typing.Optional[int]
    organization_id: int
    data_store_id: str
    name: str
    type: AssetType
    size: int
    data_element_count: typing.Optional[int]
    properties: DataAssetProps
    created_at: typing.Optional[str]
    last_modified: typing.Optional[str]
    data_classes: typing.Optional[typing.List[DataClassItem]]
    scan_start_date: typing.Optional[str]
    scan_end_date: typing.Optional[str]
    scan_priority: typing.Optional[int]
    deleted: typing.Optional[bool]
    mark_deleted_at: typing.Optional[str]
    sensitivity_score: typing.Optional[float]
    sensitivity_level: typing.Optional[int]
    retention: typing.Optional[int]
    object_count: typing.Optional[int]
    row_count: typing.Optional[int]
    public_access_level: typing.Optional[AppSchemasAssetsPublicAccessLevel]
    public_access_scan_date: typing.Optional[str]
    last_activity: typing.Optional[str]
    discovered_at: typing.Optional[str]
    last_seen_at: typing.Optional[str]
    is_known: bool
    findings_count: typing.Optional[int]
    connector_name: str = pydantic.Field(alias="Connector__name")
    connector_account_id: str = pydantic.Field(alias="Connector__account_id")
    data_store_name: str = pydantic.Field(alias="DataStore__name")
    data_store_region: typing.Optional[str] = pydantic.Field(alias="DataStore__region")
    database_engine: typing.Optional[str] = pydantic.Field(alias="Database__engine")
    connector_account_type: AccountType = pydantic.Field(alias="Connector__account_type")
    context_labels: typing.List[ContextLabelSchema]
    last_scanned: typing.Optional[str]
    similarity_type: SimilarityType
    similarity_rate: float
    similarity_size: typing.Optional[int]
    similar_pair_properties: typing.Optional[SimilarAssetsProps]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
